/*******************************************************************************
 * Institute for System Programming of the Russian Academy of Sciences
 * Copyright (c) 2009-2013
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package com.unitesk.requality_subclipse;


//import org.tigris.subversion.subclipse.core.util.SVNUrlWithPegRevision;
//import org.tigris.subversion.svnclientadapter.utils.SVNUrlUtils;
//import org.tigris.subversion.svnclientadapter.SVNClientAdapterFactory;
//import org.tigris.subversion.svnclientadapter.SVNClientException;
//import org.tigris.subversion.svnclientadapter.javahl.JhlClientAdapterFactory;
//import ru.ispras.masiw.plugin.aadl.cvcl.CVCLPlugin;
//import org.eclipse.team.core.TeamException;
//import ru.ispras.masiw.plugin.aadl.cvcl.cvclmanager.CVCLManager;
//import java.io.FileOutputStream;
//import java.io.OutputStream;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;

import org.tigris.subversion.subclipse.core.SVNTeamProvider;
import org.tigris.subversion.subclipse.core.repo.SVNRepositoryLocation;
import org.tigris.subversion.svnclientadapter.ISVNClientAdapter;
import org.tigris.subversion.svnclientadapter.ISVNDirEntry;
import org.tigris.subversion.svnclientadapter.ISVNInfo;
import org.tigris.subversion.svnclientadapter.ISVNLogMessage;
import org.tigris.subversion.svnclientadapter.SVNClientException;
import org.tigris.subversion.svnclientadapter.SVNNodeKind;
import org.tigris.subversion.svnclientadapter.SVNRevision;
import org.tigris.subversion.svnclientadapter.SVNRevisionRange;
import org.tigris.subversion.svnclientadapter.SVNUrl;
import org.tigris.subversion.svnclientadapter.utils.SVNUrlUtils;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.SubProgressMonitor;
import org.eclipse.team.core.RepositoryProvider;
import org.eclipse.core.runtime.IProgressMonitor;

import com.unitesk.requality.eclipse.cvs.CVSException;
import com.unitesk.requality.eclipse.cvs.FileSpaceTimePoint;
import com.unitesk.requality.eclipse.cvs.ICVSClient;


public class SVCSubclipseClient implements ICVSClient {
	
	private void markDelFile(File f){
		if(f.isFile())
			f.deleteOnExit();
		else
		{
			f.deleteOnExit();
			//for(File f2:f.listFiles())
				//markDelFile(f2);
		}
	}
	
	public final static String ID = "Subclipse.SVNClientAdapter";
	private String currentRevision = null;
	
	ISVNClientAdapter svnClient = null;
	String repoURL = null;
	SVNRevision revHEAD = null;
	SVNRevision rev0 = null;
	SVNRevision revCURRENT = null;
	SVNTeamProvider teamProvider = null;
	IProject project = null;
	
	//////////////////////////////////////////
	// Конструкторы и их подметоды
	//
	public SVCSubclipseClient() throws Exception {
		construct();
	}
	
	public SVCSubclipseClient(IProject proj) throws Exception {
		construct();
		if(proj != null) init(proj);
	}
	
	private void construct() throws Exception {
		svnClient = ((CVCLOverSubclipsePlugin) CVCLOverSubclipsePlugin.getDefault()).getSubclipseClientAdapter();
		if(svnClient == null) throw new Exception("construct: repository client is null");
		revHEAD = SVNRevision.HEAD;
		rev0 = SVNRevision.getRevision("0"); // exception
	}
	
	////////////////////////////////////////////
	// Методы, определённый в интерфейсе
	//
	@Override
	public String getID() {
		return ID;
	}
	@Override
	public File getContainerFromRepoS(String filePathInRepo, String rev, IProgressMonitor monitor) throws Exception {
		long k = (new Date()).getTime();
		if(svnClient == null) throw new Exception("getFileFromRepoS: repository client is null");
		if(repoURL == null || repoURL.isEmpty()) throw new Exception("getFileFromRepoS: repository URL is null or empty");
		if(filePathInRepo == null) throw new Exception("getFileFromRepoS: filePathInRepo is null");
		System.out.println("some bla bla: "+((new Date().getTime())-k));k = (new Date()).getTime();
		
		if(monitor != null) monitor.beginTask("Getting file " + filePathInRepo, 1);
		
		// УРС на файл
		SVNUrl url = buildFullURLToFile(filePathInRepo);
		System.out.println("build path: "+((new Date().getTime())-k));k = (new Date()).getTime();
		
		// ревизия файла и peg ревизия
		SVNRevision peg = SVNRevision.getRevision(rev);
		System.out.println("get rev: "+((new Date().getTime())-k));k = (new Date()).getTime();
		
		//                                    url    rev        peg
		ISVNInfo dir = svnClient.getInfo(url, peg,peg);
		if(dir.getNodeKind()!=SVNNodeKind.DIR)
			return null;
		File par = getRevisionDirectory(filePathInRepo,rev);
		//todo check
		System.out.println("precheck: "+((new Date().getTime())-k));k = (new Date()).getTime();
		
		if(par.isDirectory()){//&&par.list().length==0){
			//if(par.list().length==0){
				svnClient.checkout(url, par, peg, true);
			//}else
				//svnClient.update(par, peg, true);
		}
		System.out.println("checkout: "+((new Date().getTime())-k));k = (new Date()).getTime();
		
		markDelFile(par.getParentFile().getParentFile());
		System.out.println("markdel: "+((new Date().getTime())-k));k = (new Date()).getTime();
		
		return par;
	}
	File tempParent = null;
	
	private File getRevisionDirectory(String name,String rev) throws IOException {
		if(workingPlace == null || !workingPlace.exists()){
			tempParent = File.createTempFile("requality","svnRevisions");
			tempParent = new File(tempParent.getAbsolutePath()+"_content");
			tempParent.mkdir();
		}
		else 
			tempParent = workingPlace;
		File newDir = new File(tempParent.getAbsolutePath()+Path.SEPARATOR+"cache",name);
		//newDir.deleteOnExit();
		newDir = new File(newDir.getAbsolutePath(),"svn");
		if(!newDir.exists())
			newDir.mkdirs();
		//newDir.deleteOnExit();
		return newDir;
	}

	@Override
	public String getFileContentFromRepoS(String filePathInRepo, String rev, IProgressMonitor monitor) throws Exception {
		return getFileContentFromRepoS(filePathInRepo, rev, rev, monitor);
	}
	
	@Override
	public String getFileContentFromRepoS(String filePathInRepo, String pegRev, String revOfIntrst, IProgressMonitor monitor) throws Exception {

		if(svnClient == null) throw new Exception("getFileFromRepoS: repository client is null");
		if(repoURL == null || repoURL.isEmpty()) throw new Exception("getFileFromRepoS: repository URL is null or empty");
		if(filePathInRepo == null) throw new Exception("getFileFromRepoS: filePathInRepo is null");
		
		if(monitor != null) monitor.beginTask("Getting file " + filePathInRepo, 1);
		
		// УРС на файл
		SVNUrl url = buildFullURLToFile(filePathInRepo);

		// ревизия файла и peg ревизия
		SVNRevision peg = SVNRevision.getRevision(pegRev);
		SVNRevision rev = SVNRevision.getRevision(revOfIntrst);
		//                                    url    rev        peg
		InputStream is = svnClient.getContent(url, rev, peg);
		
		String str = null;
		if(is instanceof ByteArrayInputStream) {
			int num = ((ByteArrayInputStream) is).available();
			byte[] b = new byte[num];
			//char[] ch = new char[num];
			((ByteArrayInputStream) is).read(b);
			//for(int i = 0; i < num; i++) ch[i] = (char) b[i];
			//str = String.valueOf(ch);
			str = new String(b, "UTF-8");
		} else {
			byte[] b = new byte[is.available()];
			int numRead = is.read(b);
			str = new String("");
			while(numRead != -1) {
				str = str + new String(b, 0, numRead, "UTF-8");
				numRead = is.read(b);
			}
		}
		
		if(monitor != null) {
			monitor.worked(1);
			monitor.done();
		}
		return str;
	}
	
	@Override
	public ArrayList<FileSpaceTimePoint> getResourceRevisions(IResource componentFile, IProgressMonitor monitor) throws Exception {
		return getResourceRevisions(componentFile, null, monitor);
	}
	
	@Override
	public ArrayList<FileSpaceTimePoint> getResourceRevisions(IResource componentFile, String startRev, IProgressMonitor monitor) throws Exception {
		if(svnClient == null) throw new Exception("getFileFromRepoF: repository client is null");
		if(repoURL == null || repoURL.isEmpty()) throw new Exception("getFileFromRepoF: repository URL is null or empty");
		
		SubProgressMonitor sbMonitor = null;
		
		if(monitor == null) monitor = new NullProgressMonitor();
		
		monitor.beginTask("File history", 3);
		
		sbMonitor = new SubProgressMonitor(monitor, 1);
		
		// список точек пространства-времени репозитория для файла
		ArrayList<FileSpaceTimePoint> lst = new ArrayList<FileSpaceTimePoint>();
		FileSpaceTimePoint stp = null;
		IStorage st = teamProvider.getResourceVariant(componentFile).getStorage(sbMonitor);
		String fullPath = st == null? teamProvider.getResourceVariant(componentFile).toString(): st.getFullPath().toString();
		sbMonitor.done();
		if(sbMonitor.isCanceled()) {
			monitor.setCanceled(true);
			monitor.done();
			throw new InterruptedException();
		}
		
		sbMonitor = null;
		fullPath = fullPath.replaceFirst(":/", "://");
		fullPath = fullPath.replaceFirst(":\\d+$", "");
		fullPath = fullPath.replaceFirst(":///", "://");
		// УРС на файл
		SVNUrl url = new SVNUrl(fullPath);
		
		// массив записей из БЖ от Создания до наших дней, к сожалению, в этих записях нет имён файлов, зато есть все номера ревизий, актуалных для файла
		SVNRevision sRevision = null;
		
		if(startRev == null || startRev.isEmpty()) sRevision = rev0;
		else sRevision = SVNRevision.getRevision(startRev);
		
		sbMonitor = new SubProgressMonitor(monitor, 1);
		sbMonitor.beginTask("Getting log messages", 1);
		
		SVNRevision eRevision = null;
		if(currentRevision == null || revCURRENT == null) eRevision = SVNRevision.getRevision(getLocalCopyRevision(componentFile));
		else eRevision = revCURRENT;
		ISVNLogMessage[] svnLogMsgs = svnClient.getLogMessages(url, sRevision, eRevision);
		
		sbMonitor.worked(1);
		sbMonitor.done();
		if(sbMonitor.isCanceled()) {
			monitor.setCanceled(true);
			monitor.done();
			throw new InterruptedException();
		}
		sbMonitor = null;
		

		if(svnLogMsgs == null) throw new Exception("null pointer when getting log messages");
		
		org.tigris.subversion.svnclientadapter.ISVNInfo info = null;
		org.tigris.subversion.svnclientadapter.SVNRevision revision = null;
		
		sbMonitor = new SubProgressMonitor(monitor, 1);
		sbMonitor.beginTask("Getting info out of log messages", svnLogMsgs.length);
		
		for(int i = 0; i < svnLogMsgs.length; i++) {
			revision = SVNRevision.getRevision(svnLogMsgs[i].getRevision().toString()); // revision
			if(currentRevision == null || revCURRENT == null)
				info = svnClient.getInfo(url, revision, revHEAD);	// peg revision is either HEAD ...
			else 
				info = svnClient.getInfo(url, revision, revCURRENT);// ... or current, if available

			stp = new FileSpaceTimePoint();
			stp.setPath(info.getUrlString().replaceFirst(repoURL, ""));
			stp.setRevision(String.valueOf(info.getRevision().getNumber()));
			stp.setEpochTimeSec(info.getLastChangedDate().getTime());
			stp.setMessage(svnLogMsgs[i].getMessage());
			stp.setAuthor(svnLogMsgs[i].getAuthor());
			lst.add(stp);
			stp = null;
			sbMonitor.worked(1);
			if(sbMonitor.isCanceled()) {
				monitor.setCanceled(true);
				monitor.done();
				throw new InterruptedException();
			}
		}
		
		sbMonitor.done();
		
		return lst;
	}
	private File workingPlace;
	@Override
	public void init(IProject proj) throws Exception {
		if(proj == null) throw new Exception("NULL project");
		project = proj;
		long k = (new Date()).getTime();
		RepositoryProvider tProv = RepositoryProvider.getProvider(project,CVCLOverSubclipsePlugin.ID);
		if(!(tProv instanceof SVNTeamProvider)) throw new Exception("Team provider seems to be NOT Subclipse, but should BE Subclipse");
		System.out.println("svn team: "+((new Date().getTime())-k));k = (new Date()).getTime();
		teamProvider = (SVNTeamProvider) tProv;
		//if(teamProvider.getID().equals("org.tigris.subversion.subclipse.core.svnnature"));
		String projectAbsolutePath = (new File(project.getWorkspace().getRoot().getLocation().toFile().toString() + "/" + project.getFullPath().toString())).getAbsolutePath();
		workingPlace = new java.io.File(projectAbsolutePath + "/.reqcvs/");
		if(!workingPlace.exists())
			if(!workingPlace.mkdir()) {
				throw new CVSException("Cannot create folder " + workingPlace.getAbsolutePath());
			}
				
		repoURL = teamProvider.getSVNWorkspaceRoot().getRepository().getRepositoryRoot().toString();

		// хранить УРС на репозиторий будем без символа / в конце
		if(repoURL.charAt(repoURL.length() - 1) == '/') repoURL = repoURL.substring(0, repoURL.length() - 1);
		System.out.println("end of init : "+((new Date().getTime())-k));k = (new Date()).getTime();
	}
	
	//@Override
	public void setCurrentRevision(String rev) throws Exception {
		currentRevision = rev;
		if(currentRevision == null || currentRevision.compareTo("HEAD") == 0 || currentRevision.compareTo("-2") == 0) {
			currentRevision = null;
			revCURRENT = revHEAD;
		}
		else revCURRENT = SVNRevision.getRevision(rev);
	}

	@Override
	public String getLocalCopyRevision(IResource componentFile) throws Exception {
		try {
			String str = project.getWorkspace().getRoot().getLocation().toFile().toString() + componentFile.getFullPath().toString();
			str = str.replace(IPath.SEPARATOR, File.separatorChar);
			return svnClient.getInfo(new File(str)).getLastChangedRevision().toString();//getNumber();
		}
		catch(SVNClientException ex) {
			ex.printStackTrace();
		}
		return null;
	}

	@Override
	public void commit(IFile file, String commitMessage, IProgressMonitor monitor) throws Exception {
		if(monitor == null) monitor = new NullProgressMonitor();
		
		// альтернативный вариант
		IResource[] resources = new IResource[1];
		resources[0] = file;
		try {
			teamProvider.checkin(resources, commitMessage, false, 1, monitor);
		}
		catch(Exception ex) {
			if(monitor.isCanceled()) {
				monitor.done();
				throw new InterruptedException();
			}
			throw ex;
		}
		
		if(monitor.isCanceled()) {
			monitor.done();
			throw new InterruptedException();
		}
	}
	
	@Override
	public String getRepoURL() {
		return repoURL;		
	}
	
	@Override
	public String[] getRelativePathAndLatestRevForAFile(IFile componentFile) throws Exception {
		if(teamProvider == null) {
			repoURL = null;
			throw new CVSException("Team provider pointer is null");
		}
		
		String filePathInRepo = ((org.tigris.subversion.subclipse.core.SVNTeamProvider) teamProvider).getResourceVariant(componentFile).getStorage(null).getFullPath().toString();
		
		// отделим путь от номера ревизии
		String[] partsF = filePathInRepo.split(":");
		
		// "откусим" у УРС репозитория указание на транспортный протокол
		String[] partsR = repoURL.split(":/");
		if(!partsF[1].startsWith(partsR[1])) throw new CVSException("File seems to be not within given repository (repository/file URLs mismatch)");
		
		String[] result = new String[2];
		// делаем из полного пути относительный 
		result[0] = partsF[1].replaceFirst(partsR[1], "");
		
		// номер ревизии
		if(partsF.length >= 3 && partsF[2] != null) result[1] = partsF[2];
		else result[1] = null;
		
		return result;
	}
	
	//////////////////////////////////////////////
	// Вспомогательные методы для ынутреннего пользования
	//
	public String scratchYard(File file, String commitMessage) {
		 try {
			 File files[] = new File[1];
			 files[0] = file;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return "";
	}
	
	private SVNUrl buildFullURLToFile(String filePathInRepo) throws Exception {
		SVNUrl url = null;
		if(filePathInRepo.charAt(0) == '/') url = new SVNUrl(repoURL + filePathInRepo);
		else  url = new SVNUrl(repoURL + "/" + filePathInRepo);
		return url;
	}

	@Override
	public void excludeDotReqCSVDir() throws Exception {
		if(svnClient == null || project == null) {
			throw new Exception("The CSV client has not been properly or successfully initialized.");
		}
		File projectFile = new File(project.getWorkspace().getRoot().getLocation().toFile().toString() + "/" + project.getFullPath().toString());
		//System.out.println(projectFile.getAbsolutePath());
		svnClient.addToIgnoredPatterns(projectFile, ".reqcsv");		
	}

}
